# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetFailoverGroupsResult',
    'AwaitableGetFailoverGroupsResult',
    'get_failover_groups',
    'get_failover_groups_output',
]

@pulumi.output_type
class GetFailoverGroupsResult:
    """
    A collection of values returned by getFailoverGroups.
    """
    def __init__(__self__, failover_groups=None, id=None, in_account=None):
        if failover_groups and not isinstance(failover_groups, list):
            raise TypeError("Expected argument 'failover_groups' to be a list")
        pulumi.set(__self__, "failover_groups", failover_groups)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if in_account and not isinstance(in_account, str):
            raise TypeError("Expected argument 'in_account' to be a str")
        pulumi.set(__self__, "in_account", in_account)

    @property
    @pulumi.getter(name="failoverGroups")
    def failover_groups(self) -> Sequence['outputs.GetFailoverGroupsFailoverGroupResult']:
        """
        List of all the failover groups available in the system.
        """
        return pulumi.get(self, "failover_groups")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="inAccount")
    def in_account(self) -> Optional[str]:
        """
        Specifies the identifier for the account
        """
        return pulumi.get(self, "in_account")


class AwaitableGetFailoverGroupsResult(GetFailoverGroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFailoverGroupsResult(
            failover_groups=self.failover_groups,
            id=self.id,
            in_account=self.in_account)


def get_failover_groups(in_account: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFailoverGroupsResult:
    """
    !> **Caution: Preview Feature** This feature is considered a preview feature in the provider, regardless of the state of the resource in Snowflake. We do not guarantee its stability. It will be reworked and marked as a stable feature in future releases. Breaking changes are expected, even without bumping the major version. To use this feature, add the relevant feature name to `preview_features_enabled field` in the provider configuration. Please always refer to the Getting Help section in our Github repo to best determine how to get help for your questions.


    :param str in_account: Specifies the identifier for the account
    """
    __args__ = dict()
    __args__['inAccount'] = in_account
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('snowflake:index/getFailoverGroups:getFailoverGroups', __args__, opts=opts, typ=GetFailoverGroupsResult).value

    return AwaitableGetFailoverGroupsResult(
        failover_groups=pulumi.get(__ret__, 'failover_groups'),
        id=pulumi.get(__ret__, 'id'),
        in_account=pulumi.get(__ret__, 'in_account'))
def get_failover_groups_output(in_account: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFailoverGroupsResult]:
    """
    !> **Caution: Preview Feature** This feature is considered a preview feature in the provider, regardless of the state of the resource in Snowflake. We do not guarantee its stability. It will be reworked and marked as a stable feature in future releases. Breaking changes are expected, even without bumping the major version. To use this feature, add the relevant feature name to `preview_features_enabled field` in the provider configuration. Please always refer to the Getting Help section in our Github repo to best determine how to get help for your questions.


    :param str in_account: Specifies the identifier for the account
    """
    __args__ = dict()
    __args__['inAccount'] = in_account
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('snowflake:index/getFailoverGroups:getFailoverGroups', __args__, opts=opts, typ=GetFailoverGroupsResult)
    return __ret__.apply(lambda __response__: GetFailoverGroupsResult(
        failover_groups=pulumi.get(__response__, 'failover_groups'),
        id=pulumi.get(__response__, 'id'),
        in_account=pulumi.get(__response__, 'in_account')))
